/* Gate Local News Articles to <newsgroup>@news.demon.co.uk via AmigaNOS */

sitename = 'your_nodename.demon.co.uk'                      /* Full Domain Path  */
mqueue = 'slip:spool/mqueue/'                       /* MUST END IN SLASH */
batchfile = 'uuspool:batch/demon'                   /* Location of Gate  */
newsname = 'news.demon.co.uk'                       /* Name of News Gate */

if open( batchfile, batchfile, 'R' ) == 0 then do
    say 'unable to open' batchfile
    exit 0
    end

seqfile = mqueue || 'sequence.seq'

if open( seqfile, seqfile, 'R' ) == 0 then sequence = 1
else
    do
    sequence = ''
    sequence = readln( seqfile )
    if sequence = '' then sequence = 1
    end

close( seqfile )

do forever
    article = readln( batchfile )
    if eof( batchfile ) then leave

    article = 'uunews:' || translate( article, '/', '.' )

    if open( article, article, 'R' ) == 0 then iterate

    sequence = sequence + 1

    outtxt = mqueue || sequence || '.txt'

    if open( outtxt, outtxt, 'W' ) == 0 then iterate

    newsgroup = ''
    fromname = ''

    do forever
        string = readln( article )
        if eof( article ) then leave

        if substr( string, 1, 12 ) == 'Newsgroups: ' then newsgroup = string
        if substr( string, 1,  6 ) == 'From: '       then fromname = string

        writeln( outtxt, string )

        end

    close( article )
    close( outtxt )

    outwrk = mqueue || sequence || '.wrk'

    if newsgroup == '' || fromname == '' then do
        address command 'delete >nil:' mqueue || sequence || .txt
        sequence = sequence - 1
        iterate
        end

    fromtemp = ''
    junk = ''

    parse var fromname junk '@' fromtemp .

    if upper( fromtemp ) ~= upper( sitename ) then do
        address command 'delete >nil:' mqueue || sequence || .txt
        sequence = sequence - 1
        iterate
        end

    if open( outwrk, outwrk, 'W' ) == 0 then do
        address command 'delete >nil:' mqueue || sequence || .txt
        sequence = sequence - 1
        iterate
        end

    newsgroup = subword( newsgroup, 2 )
    parse var newsgroup newsgroup ',' .

    writeln( outwrk, newsname )
    writeln( outwrk, subword( fromname, 2, 1 ) )
    writeln( outwrk, 'mail2news@' || newsname )

    close( outwrk )

    end

close( batchfile )

if open( seqfile, seqfile, 'W' ) == 0 then do
    say 'Couldn''t open sequence file for Rewrite'
    exit 10
    end

writeln( seqfile, sequence )
close( seqfile )

address command 'delete >nil:' batchfile || '.done'
address command 'rename >nil:' batchfile batchfile || '.done'

exit
