/* copy mail received by AmigaNOS ready for elm */

rqueue = 'slip:spool/mail/'                       /* MUST END IN SLASH */
findfile = 't:ProcMail'


/*  Run find to search for the .txt files that NOS leaves lying about.  */

address command 'find >' || findfile rqueue '-name *.txt -print'

/*  Process the findfile file by file                                   */

if ~open( findfile, findfile, 'R' ) then do
    say 'Error Opening Work File. (' || findfile || ')'
    exit 1

    end

do forever

    folder = readln(findfile)
    if eof(findfile) then leave

    newfolder = left(folder, length(folder) - 4)
    say 'Processing ' folder ' to ' newfolder
    address command 'copy >nil:' folder ' ' newfolder 
    end          

close( findfile )

/* now call elm mail reader */
address command 'elm'

/* and copy files back again */

if ~open( findfile, findfile, 'R' ) then do
    say 'Error Opening Work File. (' || findfile || ')'
    exit 1

    end

do forever

    folder = readln(findfile)
    if eof(findfile) then leave

    newfolder = left(folder, length(folder) - 4)
    say 'Processing ' newfolder ' to ' folder
    address command 'copy >nil:' newfolder ' ' folder 
    end          

close( findfile )

exit
